/*
    Project: TCGINA
    Version: V1.27
    File   : setup.h

    Copyright (c) 2005-2009 Author of TCGINA DLL. All rights reserved.
    Public Key Fingerprint: 294B A769 4A0A CC05 DAE6 00DD FF47 8C72 4097 67CE

    Covered by TrueCrypt License 2.3 the full text of which is contained
    in the file License.txt included in TCGINA binary and source code
    distribution archives.

    The copyright notice of this source code file and the public key
    fingerprint must be retained in full.
*/

#ifndef __SETUP_H_D47DF546F16B490bA6D8523603A5594D
#define __SETUP_H_D47DF546F16B490bA6D8523603A5594D

#include "fileinfo.h"
#include "user.h"

#define WINLOGON_KEY \
  TEXT("SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Winlogon")
#define TCGINA_ROOT_KEY \
  TEXT("SOFTWARE\\TCGINA DLL")
#define TCGINA_KEY \
  TCGINA_ROOT_KEY TEXT("\\{D47DF546-F16B-490b-A6D8-523603A5594D}")
#define LSA_KEY \
  TEXT("SYSTEM\\CurrentControlSet\\Control\\Lsa")

#ifdef __cplusplus
extern "C" {
#endif

/* file.c */
BOOL FileExists(LPCTSTR pszFileName);
BOOL UninstallFile(LPCTSTR pszFileName, BOOL *fRebootRequired);
BOOL IsTcginaDLL(PFILE_INFO pfi);

/* reg.c */
BOOL RegKeyExists(HKEY hRootKey, LPCTSTR pszKeyName);
BOOL RegKeyIsEmpty(HKEY hRootKey, LPCTSTR pszKeyName);
BOOL RegValueExists(HKEY hRootKey, LPCTSTR pszKeyName, LPCTSTR pszValueName);
BOOL RegRemoveKey(HKEY hRootKey, LPCTSTR pszKeyName);
BOOL RegRemoveValue(HKEY hRootKey, LPCTSTR pszKeyName, LPCTSTR pszValueName);
BOOL RegCopyValue(HKEY hSrcRootKey, LPCTSTR pszSrcKeyName,
  LPCTSTR pszSrcValueName, HKEY hDestRootKey, LPCTSTR pszDestKeyName,
  LPCTSTR pszDestValueName);
BOOL RegCloneValue(HKEY hSrcRootKey, LPCTSTR pszSrcKeyName,
  LPCTSTR pszSrcValueName, HKEY hDestRootKey, LPCTSTR pszDestKeyName,
  LPCTSTR pszDestValueName);
BOOL RegGetValueData(HKEY hRootKey, LPCTSTR pszKeyName,
  LPCTSTR pszValueName, PDWORD pdwType, PBYTE pDest, PDWORD pcbSize);
BOOL RegSetString(HKEY hRootKey, LPCTSTR pszKeyName, LPCTSTR pszValueName,
  DWORD dwType, LPCTSTR pszValueData);
BOOL RegSetInteger(HKEY hRootKey, LPCTSTR pszKeyName, LPCTSTR pszValueName,
  DWORD dwData);
BOOL PendingFileRenameOperationsContains(LPCTSTR pszUpperCaseSubString);

#ifdef __cplusplus
}
#endif

#endif

